#define F_CPU 7372800UL

#include <stdlib.h>
#include <stdint.h> 
//#include <string.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#include "globals.h"
#include "lcd.h"
#include "uart.h"

#define Cint	3.08 // 2.08 uf con 2 cond in paral, 1.08 uf con 1 cond
//#define Cint	0.250 //0.250 uf con 4 cond in serie
////////   Photodiode Hamamatsu S2387-1010R   ////////
//#define nResp(y) (0.0856689*y-0.000350935*y*y+7.59366E-7*y*y*y-9.06755E-10*y*y*y*y+5.66415E-13*y*y*y*y*y-1.44695E-16*y*y*y*y*y*y-8.50112)
////////   Photodiode PP-602   ////////
#define nResp(y) (15.7113683326504-0.144424499979775*y+0.000528993256439239*y*y-9.87982531760194E-07*y*y*y+1.00046114037282E-09*y*y*y*y-5.19641799346408E-13*y*y*y*y*y+1.07425460638853E-16*y*y*y*y*y*y)

#define MULTI0 10 // 7 per 250ms
#define UART_BAUD_RATE 38400


uint8_t time_int=0;
uint8_t time_reset=0;
uint8_t slow_trigger;

uint8_t TIM0_MULTIPLIER = MULTI0;

char riga1[10]="";
char riga2[10]="";
char EEMEM SetLimp;

double Emax;
uint16_t uart_Emax_avg;
uint16_t uart_Emax_save;
uint16_t Limp;
uint16_t JOG_MULTIPLIER = 0;

uint8_t frame=0;	// Controllo sullo stato (INT-READ-RESET)
uint8_t charge=0;	// Controllo sulle batterie  (DISPLAY-PD)
char chargeDI_string[10]="";
unsigned int chargeDI;
char chargePD_string[10]="";
unsigned int chargePD;
unsigned int chargePD_OK;
unsigned int adc_PD;
unsigned int uart_Emax;
uint16_t avg=0;
uint8_t medie_avg=0;
uint16_t avg_save=0;
uint8_t battery=0;
uint8_t NOT=0;
uint8_t zero;
uint16_t Offset;
uint8_t noriga2=0;
float standard_trigger=0;
double standard_trigger_tot=0;
uint8_t delay_Emax=0;

char p;
char c_string[10]="";
unsigned int c;
uint8_t  num=0;
uint8_t trigger=0;
uint16_t i=0;

void adc_init(void){
// Activate ADC with Prescaler 128
 ADCSRA = _BV(ADEN) | _BV(ADPS0)  | _BV(ADPS1) | _BV(ADPS2);
}

uint16_t start_conversion(int ch){ 

	#define AV 30
	uint8_t i=0;
	uint16_t avgs=0;
	
	ADMUX = ch;	

	for(i=0;i<AV;i++){				
		ADCSRA |= _BV(ADSC);					
		while (ADCSRA & _BV(ADSC)){}
		avgs+=ADCW;
	}
		
	return avgs/AV;
}

ISR(TIMER0_OVF_vect){ 	// circa 247ms se MULTI0 = 7
			// Lo uso per aggiornare le righe del display
	TIM0_MULTIPLIER--;
	if(TIM0_MULTIPLIER == 0){
		i=0;

//		delay_Emax++;
//		TOGGLE_BIT(PORTC,2);

	///// **** Controllo se c'è il trigger **** /////

		if(trigger<1){ // Se NON c'e' il trigger
			sprintf(riga1,"Waitin'for");
			lcd_gotoxy(0,0);
			lcd_string(riga1);
			sprintf(riga2," Trigger  ");
			if(noriga2==0){			
				lcd_gotoxy(0,1);
				lcd_string(riga2);
			}
			if(charge>0)
				lcd_gotoxy(16,1);

		}else if (trigger != 0){ // Se c'e' il trigger
			trigger--;
			
				frame=0;

			///// *** MENU *** /////		

			if(bit_is_clear(PIND,3) && Limp < 1100){			
				if (JOG_MULTIPLIER < 10) {
					Limp++;
				}else if (JOG_MULTIPLIER > 9 && Limp < 1091){
					Limp+=10;
				}JOG_MULTIPLIER++;
			}

			if(bit_is_clear(PIND,4) && Limp > 350){			
				if (JOG_MULTIPLIER < 10) {
					Limp--;
				}else if (JOG_MULTIPLIER > 9 && Limp > 359){
					Limp-=10;
				}JOG_MULTIPLIER++;
			}

			if((bit_is_set(PIND,3)) && (bit_is_set(PIND,4)))
				JOG_MULTIPLIER = 0;
		
			eeprom_write_block((const void*)&Limp, (void*)&SetLimp, sizeof(Limp));

			if((bit_is_clear(PIND,3)) && (bit_is_clear(PIND,4)) && zero > 10){
				Offset = uart_Emax-Offset;
				zero = 0;
			}else if (delay_Emax==1){
				if(uart_Emax<1)
					Emax=0;
				else{
				   //for(int t=0;t<=4;t++){
				   //   uart_Emax_avg+=uart_Emax;
				   //}
				   //uart_Emax_avg=uart_Emax_avg>>2;
				   Emax = (((uart_Emax-Offset)* 0.00316*Cint/nResp(Limp))/avg_save); // 0.00488
				   uart_Emax = 0;
				   if(Emax > 60){
					Emax = 0;
					delay_Emax=0;
					medie_avg=0;
					uart_Emax_save=0;
				   }
				}
				if(Emax<0) Emax=0;
				if(zero<12)
					zero++;
			}

			sprintf(riga1,"  %dnm   ",Limp);
			lcd_gotoxy(0,0);
			lcd_string(riga1);
			if(noriga2 == 0 && delay_Emax==1){
				sprintf(riga2," %.3fuJ  ",Emax);
				lcd_gotoxy(0,1);
				lcd_string(riga2);
				delay_Emax=2;
				medie_avg=0;
			}else if (delay_Emax==0){
				lcd_gotoxy(0,1);
				lcd_string(" 0.000uJ  ");
			}
			lcd_gotoxy(16,1);

		}

	///// *** Fine del controllo del trigger *** /////

	///// ***  Scrittura e calcolo batteria  *** /////
		if((charge<1 && frame==0) || trigger<1){
			uart_putc(1);	// Chiede di farsi mandare lo
					// stato della batteria del PD
			if(trigger<1)
				uart_putc(5);

			lcd_gotoxy(10,0);		
			lcd_string("|DI");
			chargeDI = (start_conversion(6) - 520)/1.03; // Valore in ADC
			if(chargeDI>99 && chargeDI<200)
				chargeDI=99;		// Se va poco sopra scrive 99%
			else if(chargeDI>200)
				chargeDI=0;		// Se va poco sotto scrive 0%
			utoa(chargeDI,chargeDI_string,10);
			if(chargeDI<10)
				lcd_string(" ");
			lcd_string(chargeDI_string);
			lcd_string("%");
			if(noriga2 == 0){
				lcd_gotoxy(10,1);
				lcd_string("|PD");
			}
			chargePD_OK = uart_getc();
			if (chargePD_OK & UART_NO_DATA){ // SE NON C'E' NESSUN DATO CON TRIGGER
				//chargePD=0;
				if(NOT<1){
					lcd_string("NOT");
					delay_Emax=0;
				} else if(NOT>0){					
					lcd_gotoxy(16,1);
					NOT--;
				}
			}else{
				NOT=2;
				if(chargePD_OK == 1){
					noriga2=0;
					chargePD = uart_getc();
					utoa(chargePD,chargePD_string,10);
					if(chargePD<10)
						lcd_string(" ");
					lcd_string(chargePD_string);
					lcd_string("%");
				}else{
					noriga2=1;
					lcd_gotoxy(1,1);
					lcd_string("CALIBRATION... ");
				}
			}
			if(trigger<1)
				frame=0;
			else
				frame=1;
			charge=0; // 4 Ping con PD 1 volta a secondo - Multipli di 4 x sec
		}else if (charge>0 && frame==0){
			charge--;
		}


		if ((standard_trigger<6 && slow_trigger==1) || standard_trigger<5){
			time_reset = 1;
			time_int = 0;
			TIM0_MULTIPLIER=12;
			slow_trigger=1;
		}else{
			standard_trigger_tot=standard_trigger/322; // 322 colpi di clock per ogni timer0 azzerato con MULTI0 = 10
			standard_trigger_tot*=69;
			double approx = abs(standard_trigger_tot-(int)standard_trigger_tot);
			if(approx >= 0.5)
				time_reset=(int)standard_trigger_tot+1;
			else
				time_reset=(int)standard_trigger_tot;
 
			standard_trigger_tot=standard_trigger/322; // 322 colpi di clock per ogni timer0 azzerato con MULTI0 = 10
			standard_trigger_tot*=89; // forse ok anche 99
			approx = abs(standard_trigger_tot-(int)standard_trigger_tot);
			if(approx >= 0.5)
				time_int=(int)standard_trigger_tot+1;
			else
				time_int=(int)standard_trigger_tot;
			TIM0_MULTIPLIER=10;
			slow_trigger=0;
		}

		standard_trigger=0;

//		TIM0_MULTIPLIER = MULTI0;
	}
}

ISR(TIMER1_OVF_vect){

	standard_trigger++;
	
	trigger=2; 	// Utilizzato per gestire il controllo del Trigger
			// più sarà alto più ci metterà a far il controllo
					
		switch(frame){
			case 1: // FASE INTEGRAZIONE
				i++;

				if(i>time_reset){ 
					uart_putc(2);
					frame=2;
					i=0;
				}
			break;
			case 2:	// FASE DI LETTURA
				i++;
				avg++;
				if(i>time_int){ // LIMITE i>119
					uart_putc(3); // DICE DI INIZIARE LA FASE DI HOLD
					if(bit_is_clear(PINC,0))
						uart_Emax = uart_getc(); // RICEVE L'AVVERTIMENTO
					if(uart_Emax & UART_NO_DATA){
						uart_Emax = 0;
					}else if(uart_Emax == 3){ // AVVERTE CHE STA PER MANDARE IL DATO 
						uart_Emax = uart_getc(); // RICEVE IL DATO DELL'ENERGIA
						medie_avg++;
						i=0;
						uart_Emax=(uart_Emax*4)+uart_Emax_save;
						uart_Emax_save=uart_Emax;
						avg_save = avg;
						frame=3;
						if(medie_avg>=5){
							delay_Emax=1;
							uart_Emax/=medie_avg;
							uart_Emax_save=0;
						}
					}
				}
			break;
			case 3: // FASE DI RESET
				avg=0;
/*
				i++;	
				if(i>49&&bit_is_clear(PINC,0)){
					frame=0;
					i=0;
					uart_putc(4);
				}
*/
			break;

		}
	TCNT1 = 65535; // 65431
}

int main(void){

	//configurazione timer/counter 0	
	TIMSK0|=(1<<TOIE0);//overflow vector
  	TCCR0B|=(1<<CS02)|(1<<CS00);//1024 prescaler CS02 1 - CS00 1
 	TCNT0 = 0;

	//configurazione timer/counter 1
	TIMSK1|=(1<<TOIE1);	//overflow vector
  	TCCR1B|=(1<<CS12)|(1<<CS11)|(1<<CS10);//T1 on rising edge 1 - 1 - 1
 	TCNT1 = 65535;


/********************************* CONTROLLO TRASMISSIONE ***************************/
	SET_BIT_AS_OUT(DDRD,2);	// Imposto se metterlo in stand-by o in funzione
	SET_BIT(PORTD,2);	// 0 STAND-BY | 1 WORK
	SET_BIT_AS_OUT(DDRC,1);	// Imposto se pronto a scrivere o ricevere il dato
	CLEAR_BIT(PORTC,1);	// 0 READY | 1 NOT READY
	SET_BIT_AS_IN(DDRC,0);	// Leggo se il modulo è occupato o libero
//	CLEAR_BIT(PORTC,0);	// 0 FREE | 1 BUSY
/********************************* ********************** ***************************/
	SET_BIT_AS_IN(DDRD,3);	// TASTO UP
	SET_BIT(PORTD,3);
	SET_BIT_AS_IN(DDRD,4);	// TASTO DOWN
	SET_BIT(PORTD,4);

	SET_BIT_AS_IN(DDRC,3);	// CONTROLLO SE LA RICEZIONE E' ANDATA A BUON FINE
	SET_BIT_AS_IN(DDRC,4);	// CONTROLLO SE LA TRASMISSIONE E' ANDATA A BUON FINE


	SET_BIT_AS_OUT(DDRC,5);	// CONTROLLO DI UN PIN LIBERO
//	SET_BIT(PORTC,7);

	lcd_init();
	lcd_home();
	lcd_clrscr();	
	adc_init();
	uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU));

	sei();

eeprom_read_block((void*)&Limp, (const void*)&SetLimp, sizeof(Limp));

	if(Limp<350 || Limp>1100)
		Limp=500;

	while(1){

/*		c=uart_getc();
		if(c==3 && num==0){
			utoa(c,c_string,10);
			lcd_gotoxy(0,0);
			lcd_string(c_string);
			lcd_string("  ");
			CLEAR_BIT(PORTC,2);
			num=1;
		}
		if(num==1 && bit_is_clear(PINC,0)){
			lcd_string("5");
			SET_BIT(PORTC,2);
			uart_putc(5);
			num=0;
		}		
*/
	}
	
return 0;
}
